﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.TreeView;
using Telerik.Windows.DragDrop;

namespace BaseApplicationProject
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            this.treeView1.ItemsSource = GenerateItems(4);

            DragDropManager.AddDragInitializeHandler(this.treeView1, OnDragInitialize, true);
        }

        private void OnDragInitialize(object sender, DragInitializeEventArgs e)
        {
            RadTreeView tree = (RadTreeView)sender;
            DataItem selectedItem = tree.SelectedItem as DataItem;

            if (!selectedItem.IsDraggable)
            {
                e.Cancel = true;
            }
        }

        private IEnumerable GenerateItems(int p)
        {
            var result = new ObservableCollection<DataItem>();
            for (int i = 0; i < p; i++)
            {
                DataItem dataItem = new DataItem();
                dataItem.Header = "Item " + i;
                for (int j = 0; j < 3; j++)
                {
                    var childItem = new DataItem { Header = "Item " + i + "." + j };
                    if (i == 0 && j == 2)
                    {
                        childItem.IsDraggable = false;
                    }
                    dataItem.Children.Add(childItem);
                }
                result.Add(dataItem);
            }

            return result;
        }
    }

    public class DataItem
    {
        public DataItem()
        {
            this.Children = new ObservableCollection<DataItem>();
            this.IsDraggable = true;
        }

        public string Header { get; set; }
        public ObservableCollection<DataItem> Children { get; set; }
        public bool IsDraggable { get; set; }
    }
}
